<?php
/**
 * vrpayecommerce_klarna_obt class to create VR pay eCommerce Online Bank Transfer payment method in Gambio
 *
 * @package     modules.payment
 * @subpackage  vrpayecommerce
 */

require_once 'vrpayecommerce/vrpayecommerce_base.php';

class vrpayecommerce_klarna_obt extends vrpayecommerceBase
{
    /**
     * Constructor Function
     *
     * @return  void
     */
    public function __construct()
    {
        $this->code = "vrpayecommerce_klarna_obt";
        $this->brand = 'SOFORTUEBERWEISUNG';
        if ($_SESSION['language_code'] == 'de') {
            $this->logo = "klarna_obt_de.png";
        } else {
            $this->logo = "klarna_obt_en.png";
        }
        parent::__construct();
    }
}
MainFactory::load_origin_class('vrpayecommerce_klarna_obt');
